$APPTYPE CONSOLE: $TYPECHECK ON

$INCLUDE "HotXLS.inc"

$OPTION DIM LONG
CONST flen=11  'FIELD WIDTH.  CHANGE IT AS YOU LIKE.

Declare SUB Field(c$ AS STRING)
DIM t$ As STRING
DIM retv As LONG, sh As LONG, ir As LONG, ic As LONG
DIM maxcol As LONG, prtrow As LONG, prtcol As LONG, maxrow AS LONG

App.Title="HotXLS 1.3"

PRINT "This demo shows use of HotXLS functions in a console or GUI application."
PRINT "This demo does not check if you are overwriting/replacing a file."
PRINT "Therefore, use a *different* file name to save files as you test it."
PRINT
xIntegrity = 0 'xIntegrity = 1 TO FORCE READ OF EVERY BIFF8 RECORD ON OPEN

NextFile:
color 11
INPUT "xls file specification (Enter to quit) = "; FileSpec
IF NOT FileSpec.length THEN Goto ProgEnd
IF NOT INSTR(FileSpec,".") THEN FileSpec.WriteStr(".xls",4)
color 7
PRINT "Parsing "; FileSpec; ", please wait..."
retv = xlsOPEN

PRINT "No. of Sheets = "; STR$(retv); space; sERR
'PrintSheetNames: PrintSSTRecords 'REMOVE COMMENT TO SEE INTERNAL DATA
IF retv<1 THEN Goto NextFile

WriteValue:
color 14
INPUT "WRITE sheet (1 to "+STR$(nSR)+", 0 to quit)= "; t$
sh=val(t$)
IF NOT sh THEN Goto GetValue
WriteValue1:
INPUT "WRITE row ("+STR$(xlsMINROW(sh)+1)+" to "+STR$(xlsMAXROW(sh)+1)+", 0 to quit)= "; t$
ir=val(t$)
IF NOT ir THEN Goto WriteValue
WriteValue2:
INPUT "WRITE column (1 to 256, 0 to quit)= "; t$
ic=val(t$)
IF NOT ic THEN Goto WriteValue1
INPUT "new value (anything including null) = "; t$
retv=xlsWRITE(sh,ir-1,ic-1,t$)
'PRINT "WRITE = "+STR$(ret)+" bytes written.
IF sERR.Length THEN PRINT "Write Error: "+sERR 
Goto WriteValue2

GetValue:
color 7
INPUT "READ sheet (1 to "+STR$(xlsNUMBERSHEETS)+", 0 to quit)= "; t$
sh=val(t$)
IF sh < 1 THEN Goto xlsDone
IF sh > nSR THEN PRINT "No Sheet "; STR$(sh): Goto GetValue

GetColInput:
INPUT "READ column ("+STR$(xlsMINCOL(sh)+1)+" to "+STR$(xlsMAXCOL(sh)+1)+", 0 to quit)= "; t$
prtcol=val(t$)
IF prtcol < 1 THEN Goto GetValue
prtcol=prtcol-1
IF prtcol < xlsMINCOL(sh) OR prtcol > xlsMAXCOL(sh) THEN
  PRINT "No Column "; STR$(prtcol+1): Goto GetColInput
END IF

GetRowInput:
INPUT "READ row ("+STR$(xlsMINROW(sh)+1)+" to "+STR$(xlsMAXROW(sh)+1)+", 0 to quit)= "; t$
prtrow=val(t$)
IF prtrow < 1 THEN Goto GetColInput
prtrow=prtrow-1
IF prtrow < xlsMINROW(sh) OR prtrow > xlsMAXROW(sh) THEN
  PRINT "No Row "; STR$(prtrow+1): Goto GetRowInput
END IF
maxrow = prtrow + 19
IF maxrow > xlsMAXROW(sh) THEN maxrow = xlsMAXROW(sh)
maxcol=xlsMAXCOL(sh)
IF maxcol-prtcol > 5 THEN maxcol=prtcol+5
color 10
Field(SheetName(sh))  'xlsSHEETNAME(sh))
For ic = prtcol to maxcol 
Field(CHR$(65+ic)): NEXT ic: PRINT
For ir = prtrow to maxrow    'USE NEXT LINE INSTEAD TO DISPLAY ALL ROWS
''For ir = xlsMINROW(sh) to xlsMAXROW(sh)
color 10
t$="Row "+STR$(ir+1): Field(t$)
color 7
For ic = prtcol to maxcol
t$=xlsREAD(sh,ir,ic)
''IF t$="" THEN t$=sERR      'REMOVE COMMENT TO SEE sERR STRINGS
''t$=RIGHT$(HEX$(xFormat),4) 'REMOVE COMMENT TO SEE xFormat VALUES
Field(t$): NEXT ic
PRINT: NEXT ir
Goto GetRowInput

xlsDone:
color 14
INPUT "Save file name (without extension; null = no)? "; t$
IF t$.length THEN 
  retv=xlsSAVE(t$+".xls")
  IF retv < 1 THEN PRINT sERR ELSE PRINT t$; ".xls size = "; STR$(retv)
END IF
color 7
retv = xlsCLOSE
IF NOT retv THEN Goto NextFile
PRINT "Error closing file"
ProgEnd:
END

SUB Field(c$ AS STRING)
PRINT LEFT$(c$,flen);
IF c$.length<flen THEN PRINT SPACE$(flen-c$.length);
END SUB
